Index: trunk/kernel/syscalls/sys_lseek.c
===================================================================
--- trunk/kernel/syscalls/sys_lseek.c	(revision 690)
+++ trunk/kernel/syscalls/sys_lseek.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * kern/sys_lseek.c - Kernel function implementing the lseek system call.
+ * kern/sys_lseek.c - set the read/write offset of an opened file 
  * 
- * AUthor        Alain Greiner (2016,2017,2018,2019)
-s
- * Copyright (c) UPMC Sorbonne Universites
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-kernel.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,96 +17,40 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <errno.h>
+#include <types.h>
 #include <vfs.h>
-#include <vmm.h>
 #include <thread.h>
-#include <printk.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
 
-/////////////////////////////////
-int sys_lseek ( uint32_t file_id,
-                uint32_t offset,
-                uint32_t whence )
+int sys_lseek (uint_t fd, off_t offset, int whence)
 {
-	error_t    error;
-    xptr_t     file_xp;
-    uint32_t   new_offset;
+	error_t err = 0;
+	size_t new_offset;
+	struct thread_s *this;
+	struct task_s *task;
+	struct vfs_file_s *file;
 
-	thread_t  * this    = CURRENT_THREAD;
-	process_t * process = this->process;
+	file = NULL;
+	this = current_thread;
+	task = current_task;
 
-#if (DEBUG_SYS_LSEEK || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_LSEEK
-if( DEBUG_SYS_LSEEK < tm_start )
-printk("\n[%s] thread[%x,%x] enter / file_id %d / offset %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, file_id, offset, (uint32_t)tm_start );
-#endif
-
-    // check file_id argument
-	if( file_id >= CONFIG_PROCESS_FILE_MAX_NR )
+	/* FIXME: file may be closed in parallel 
+	 * of seek/read/write/mmap ..etc 
+	 * so file may be NULL or invalid */
+	if((fd >= CONFIG_TASK_FILE_MAX_NR) || (task_fd_lookup(task, fd, &file)))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] illegal file descriptor index %d\n",
-__FUNCTION__ , process->pid, this->trdid, file_id );
-#endif
-		this->errno = EBADFD;
+		this->info.errno = EBADFD;
 		return -1;
 	}
 
-    // get extended pointer on remote file descriptor
-    file_xp = process_fd_get_xptr_from_local( process , file_id );
-
-    if( file_xp == XPTR_NULL )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] undefined fd_id %d\n",
-__FUNCTION__, process->pid, this->trdid, file_id );
-#endif
-		this->errno = EBADFD;
-		return -1;
-    }
-
-// FIXME: file may be closed in parallel of seek/read/write/mmap ..etc 
-
-    // call relevant VFS function
-	error = vfs_lseek( file_xp , offset , whence , &new_offset );
-
-	if( error )
+	if((err = vfs_lseek(file, offset, whence, &new_offset)))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot seek file_id %d\n",
-__FUNCTION__, process->pid, this->trdid, file_id );
-#endif
-		this->errno = error;
+		this->info.errno = (err < 0) ? -err : err;
 		return -1;
 	}
-
-#if (DEBUG_SYS_LSEEK || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_LSEEK
-if( DEBUG_SYS_LSEEK < tm_end )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__ , process->pid, this->trdid, (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_LSEEK] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_LSEEK] , 1 );
-#endif
   
 	return new_offset;
